

#include "BUILTIN.h"
extern OBJ _AMap_31(OBJ,OBJ,OBJ,OBJ);extern OBJ __AMap_31;
extern OBJ _AString_57(OBJ);extern OBJ __AString_57;

#include "Nat.h"

#include "Char.h"
extern OBJ _ASeqConv_3(OBJ,OBJ,OBJ,OBJ,OBJ);extern OBJ __ASeqConv_3;
extern OBJ _ASeqConv_5(OBJ,OBJ,OBJ,OBJ,OBJ);extern OBJ __ASeqConv_5;
extern OBJ __ASeqConv_8;
extern OBJ _APairConv_4(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);extern OBJ __APairConv_4;
extern OBJ _AMapNotForUserPurpose_4(OBJ,OBJ,OBJ);extern OBJ __AMapNotForUserPurpose_4;
extern OBJ _ABSTreeConv_7(OBJ,OBJ);extern OBJ __ABSTreeConv_7;
extern OBJ _AStringConv_1(OBJ);extern OBJ __AStringConv_1;
extern OBJ _ACompose_4(OBJ,OBJ,OBJ);extern OBJ __ACompose_4;
extern OBJ __ATree_7;
extern OBJ _ACAST_3(OBJ);extern OBJ __ACAST_3;
extern OBJ _AMapConv_4(OBJ,OBJ);OBJ __AMapConv_4; /* asSeq */
extern OBJ _AMapConv_5(OBJ,OBJ);OBJ __AMapConv_5; /* asMap */
extern OBJ _AMapConv_6(OBJ,OBJ,OBJ,OBJ);OBJ __AMapConv_6; /* ` */
extern OBJ _AMapConv_7(OBJ,OBJ,OBJ,OBJ);OBJ __AMapConv_7; /* `,1 */
extern OBJ _AMapConv_8(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __AMapConv_8; /* `,2 */
extern OBJ _AMapConv_9(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __AMapConv_9; /* `,3 */
extern OBJ _AMapConv_10(OBJ,OBJ);OBJ __AMapConv_10; /* explode */
extern OBJ _AMapConv_11(OBJ,OBJ);OBJ __AMapConv_11; /* implode */
OBJ __AMapConv_12; /* `,2'12 */
OBJ __AMapConv_13; /* `'13 */
OBJ __AMapConv_14; /* `'14 */
OBJ __AMapConv_15; /* `'15 */

extern OBJ _AMapConv_4(OBJ x1,OBJ x2) /* asSeq */
{OBJ r;
 CPCLS(__AMapNotForUserPurpose_4,1);
 {OBJ x3;OBJ x4;
  x3=(*(OBJ(*)(OBJ,OBJ))METHOD(__AMapNotForUserPurpose_4,1))(__AMapNotForUserPurpose_4,x1);
  x4=_ACAST_3(x2);
  r=_ABSTreeConv_7(x3,x4);}
 return r;}

extern OBJ _AMapConv_5(OBJ x1,OBJ x2) /* asMap */
{OBJ r;
 if(ISPRM(x2)){
  FRCLS(x1,1);
  r=__ATree_7;
 }else{
  {OBJ x29=FLD1(x2,1);OBJ x30=FLD1(x2,2);
   if(EXPRD(x2,1)){
    DSPRDF(x2);
   }else{
    CPPRD(x29,1);COPY(x30,1);
    FRPRD(x2,1);}
   CPCLS(x1,1);
   {OBJ x32;
    x32=_AMapConv_5(x1,x30);
    {OBJ x33=FLD1(x29,1);OBJ x34=FLD1(x29,2);
     if(EXPRD(x29,1)){
      DSPRDF(x29);
     }else{
      COPY(x33,1);COPY(x34,1);
      FRPRD(x29,1);}
     r=_AMap_31(x1,x33,x34,x32);}}}}
 return r;}

extern OBJ _AMapConv_6(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* ` */
{OBJ r;
 CPPRD(__AMapConv_13,1);
 CPPRD(__AMapConv_14,1);
 CPPRD(__AMapConv_15,1);
 CPPRD(__ASeqConv_8,1);
 r=_AMapConv_8(x1,__AMapConv_13,__AMapConv_14,__ASeqConv_8,__AMapConv_15,x2,x3,x4);
 return r;}

extern OBJ _AMapConv_7(OBJ x1,OBJ x2,OBJ x3,OBJ x4) /* `,1 */
{OBJ r;
 CPPRD(__AMapConv_13,1);
 CPPRD(__AMapConv_14,1);
 CPPRD(__AMapConv_15,1);
 CPPRD(__ASeqConv_8,1);
 r=_AMapConv_9(x1,__AMapConv_13,__AMapConv_14,__ASeqConv_8,__AMapConv_15,x2,x3,x4);
 return r;}

extern OBJ _AMapConv_8(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6,OBJ x7,OBJ x8) /* `,2 */
{OBJ r;
 CPPRD(__AMapConv_12,2);
 CPCLS(__APairConv_4,1);
 CPCLS(__AMapNotForUserPurpose_4,1);
 {OBJ x9;OBJ x10;OBJ x11;OBJ x12;
  x9=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__APairConv_4,5))(__APairConv_4,__AMapConv_12,x2,__AMapConv_12,x6,x7);
  x10=(*(OBJ(*)(OBJ,OBJ))METHOD(__AMapNotForUserPurpose_4,1))(__AMapNotForUserPurpose_4,x1);
  x11=_ACAST_3(x8);
  x12=_ABSTreeConv_7(x10,x11);
  r=_ASeqConv_3(x3,x4,x5,x9,x12);}
 return r;}

extern OBJ _AMapConv_9(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5,OBJ x6,OBJ x7,OBJ x8) /* `,3 */
{OBJ r;
 CPPRD(__AMapConv_12,2);
 CPCLS(__AString_57,1);
 CPCLS(__APairConv_4,1);
 CPCLS(__AMapNotForUserPurpose_4,1);
 CPCLS(__AStringConv_1,2);
 CPCLS(__ACompose_4,3);
 {OBJ x9;OBJ x10;OBJ x11;OBJ x12;OBJ x13;OBJ x14;OBJ x15;
  x9=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ACompose_4,2))(__ACompose_4,__AStringConv_1,x6);
  x10=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ACompose_4,2))(__ACompose_4,__AStringConv_1,x7);
  x11=(*(OBJ(*)(OBJ,OBJ))METHOD(__AMapNotForUserPurpose_4,1))(__AMapNotForUserPurpose_4,x1);
  x12=_ACAST_3(x8);
  x13=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))METHOD(__APairConv_4,5))(__APairConv_4,__AMapConv_12,x2,__AMapConv_12,x9,x10);
  x14=_ABSTreeConv_7(x11,x12);
  x15=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__ACompose_4,2))(__ACompose_4,__AString_57,x13);
  r=_ASeqConv_5(x3,x4,x5,x15,x14);}
 return r;}

extern OBJ _AMapConv_10(OBJ x1,OBJ x2) /* explode */
{OBJ r;
 r=_AMapConv_4(x1,x2);
 return r;}

extern OBJ _AMapConv_11(OBJ x1,OBJ x2) /* implode */
{OBJ r;
 r=_AMapConv_5(x1,x2);
 return r;}

static OBJ _mt_8_0_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,2);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 return r;}

static OBJ _mt_8_0_5(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4,OBJ t5) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,5);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 FLDCLS(r,3)=t3;
 FLDCLS(r,4)=t4;
 FLDCLS(r,5)=t5;
 return r;}

static OBJ _mt_8_0_7(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4,OBJ t5,OBJ t6,OBJ t7) 
{OBJ r;
 DPCLS(t,r);
 INCCLS(r,0,7);
 FLDCLS(r,1)=t1;
 FLDCLS(r,2)=t2;
 FLDCLS(r,3)=t3;
 FLDCLS(r,4)=t4;
 FLDCLS(r,5)=t5;
 FLDCLS(r,6)=t6;
 FLDCLS(r,7)=t7;
 return r;}

static OBJ _mt_8_1_1(OBJ t,OBJ t1) 
{OBJ r;
 if(EXCLS(t)){
  r=t;
 }else{
  DPCLS(t,r);
  FLDCLS(r,1)=FLDCLS(t,1);
  COPY(FLDCLS(r,1),1);}
 INCCLS(r,1,1);
 FLDCLS(r,2)=t1;
 return r;}

static OBJ _mt_8_1_4(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4) 
{OBJ r;
 if(EXCLS(t)){
  r=t;
 }else{
  DPCLS(t,r);
  FLDCLS(r,1)=FLDCLS(t,1);
  COPY(FLDCLS(r,1),1);}
 INCCLS(r,1,4);
 FLDCLS(r,2)=t1;
 FLDCLS(r,3)=t2;
 FLDCLS(r,4)=t3;
 FLDCLS(r,5)=t4;
 return r;}

static OBJ _mt_8_1_6(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4,OBJ t5,OBJ t6) 
{OBJ r;
 if(EXCLS(t)){
  r=t;
 }else{
  DPCLS(t,r);
  FLDCLS(r,1)=FLDCLS(t,1);
  COPY(FLDCLS(r,1),1);}
 INCCLS(r,1,6);
 FLDCLS(r,2)=t1;
 FLDCLS(r,3)=t2;
 FLDCLS(r,4)=t3;
 FLDCLS(r,5)=t4;
 FLDCLS(r,6)=t5;
 FLDCLS(r,7)=t6;
 return r;}

static OBJ _mt_8_2_3(OBJ t,OBJ t1,OBJ t2,OBJ t3) 
{OBJ r;
 if(EXCLS(t)){
  r=t;
 }else{
  DPCLS(t,r);
  FLDCLS(r,1)=FLDCLS(t,1);
  FLDCLS(r,2)=FLDCLS(t,2);
  COPY(FLDCLS(r,1),1);
  COPY(FLDCLS(r,2),1);}
 INCCLS(r,2,3);
 FLDCLS(r,3)=t1;
 FLDCLS(r,4)=t2;
 FLDCLS(r,5)=t3;
 return r;}

static OBJ _mt_8_2_5(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4,OBJ t5) 
{OBJ r;
 if(EXCLS(t)){
  r=t;
 }else{
  DPCLS(t,r);
  FLDCLS(r,1)=FLDCLS(t,1);
  FLDCLS(r,2)=FLDCLS(t,2);
  COPY(FLDCLS(r,1),1);
  COPY(FLDCLS(r,2),1);}
 INCCLS(r,2,5);
 FLDCLS(r,3)=t1;
 FLDCLS(r,4)=t2;
 FLDCLS(r,5)=t3;
 FLDCLS(r,6)=t4;
 FLDCLS(r,7)=t5;
 return r;}

static OBJ _mt_8_2_6(OBJ t,OBJ t1,OBJ t2,OBJ t3,OBJ t4,OBJ t5,OBJ t6) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),t1,t2,t3,t4,t5,t6);
 return r;}

static OBJ _mt_8_5_2(OBJ t,OBJ t1,OBJ t2) 
{OBJ r;
 if(EXCLS(t)){
  r=t;
 }else{
  DPCLS(t,r);
  FLDCLS(r,1)=FLDCLS(t,1);
  FLDCLS(r,2)=FLDCLS(t,2);
  FLDCLS(r,3)=FLDCLS(t,3);
  FLDCLS(r,4)=FLDCLS(t,4);
  FLDCLS(r,5)=FLDCLS(t,5);
  COPY(FLDCLS(r,1),1);
  COPY(FLDCLS(r,2),1);
  COPY(FLDCLS(r,3),1);
  COPY(FLDCLS(r,4),1);
  COPY(FLDCLS(r,5),1);}
 INCCLS(r,5,2);
 FLDCLS(r,6)=t1;
 FLDCLS(r,7)=t2;
 return r;}

static OBJ _mt_8_5_3(OBJ t,OBJ t1,OBJ t2,OBJ t3) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  COPY(FLDCLS(t,3),1);
  COPY(FLDCLS(t,4),1);
  COPY(FLDCLS(t,5),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),FLDCLS(t,5),t1,t2,t3);
 return r;}

static OBJ _mt_8_7_1(OBJ t,OBJ t1) 
{OBJ r;
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  COPY(FLDCLS(t,1),1);
  COPY(FLDCLS(t,2),1);
  COPY(FLDCLS(t,3),1);
  COPY(FLDCLS(t,4),1);
  COPY(FLDCLS(t,5),1);
  COPY(FLDCLS(t,6),1);
  COPY(FLDCLS(t,7),1);
  DCCLS(t,1);}
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),FLDCLS(t,5),FLDCLS(t,6),FLDCLS(t,7),t1);
 return r;}
static OBJ _mt_8_7_1_l(OBJ t,OBJ t1) 
{OBJ r;
 r=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ,OBJ))ENTRY(t))(FLDCLS(t,1),FLDCLS(t,2),FLDCLS(t,3),FLDCLS(t,4),FLDCLS(t,5),FLDCLS(t,6),FLDCLS(t,7),t1);
 if(EXCLS(t)){
  DSCLSF(t);
 }else{
  DCCLS(t,1);
  FLDCLS(t,1)=NIL;FLDCLS(t,2)=NIL;FLDCLS(t,3)=NIL;FLDCLS(t,4)=NIL;FLDCLS(t,5)=NIL;FLDCLS(t,6)=NIL;FLDCLS(t,7)=NIL;
  COPY(r,1);LZYCLS(t,r);}
 return r;}

init_AMapConv()
{
 static int visited=0; if(visited) return; visited=1;
 init_AMap();
 init_ASeq();
 init_APair();
 init_AString();
 init_ANat();
 init_AChar();
 init_AOption();
 init_ASet();
 init_ASeqConv();
 init_APairConv();
 init_AMapNotForUserPurpose();
 init_ASetByBST();
 init_ASetByBSTConv();
 init_ABSTree();
 init_ABSTreeConv();
 init_AStringConv();
 init_ACompose();
 init_ATree();
 init_ACAST();
 init_ATreeMap();
 init_AStringMapSeq();
 DEN("}",__AMapConv_15);
 DEN("{",__AMapConv_14);
 DEN(" -> ",__AMapConv_13);
 DEN("",__AMapConv_12);
 CLS(2,_AMapConv_11,__AMapConv_11);
 CLS(2,_AMapConv_10,__AMapConv_10);
 CLS(8,_AMapConv_9,__AMapConv_9);
 CLS(8,_AMapConv_8,__AMapConv_8);
 CLS(4,_AMapConv_7,__AMapConv_7);
 CLS(4,_AMapConv_6,__AMapConv_6);
 CLS(2,_AMapConv_5,__AMapConv_5);
 CLS(2,_AMapConv_4,__AMapConv_4);
 MTH(8,0,2,_mt_8_0_2);LZYMTH(8,0,2,_mt_8_0_2);
 MTH(8,0,5,_mt_8_0_5);LZYMTH(8,0,5,_mt_8_0_5);
 MTH(8,0,7,_mt_8_0_7);LZYMTH(8,0,7,_mt_8_0_7);
 MTH(8,1,1,_mt_8_1_1);LZYMTH(8,1,1,_mt_8_1_1);
 MTH(8,1,4,_mt_8_1_4);LZYMTH(8,1,4,_mt_8_1_4);
 MTH(8,1,6,_mt_8_1_6);LZYMTH(8,1,6,_mt_8_1_6);
 MTH(8,2,3,_mt_8_2_3);LZYMTH(8,2,3,_mt_8_2_3);
 MTH(8,2,5,_mt_8_2_5);LZYMTH(8,2,5,_mt_8_2_5);
 MTH(8,2,6,_mt_8_2_6);LZYMTH(8,2,6,_mt_8_2_6);
 MTH(8,5,2,_mt_8_5_2);LZYMTH(8,5,2,_mt_8_5_2);
 MTH(8,5,3,_mt_8_5_3);LZYMTH(8,5,3,_mt_8_5_3);
 MTH(8,7,1,_mt_8_7_1);LZYMTH(8,7,1,_mt_8_7_1_l);}

